import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;

/**
 * A class for testing the HuffmanTree.
 * 
 * Includes some provided testing code; you are welcome to add more.
 * @author Joel
 * @version Fa 2014
 */
public class HuffmanTester
{
	public static void main(String[] args)
	{
		/* STRING CODEC TESTING */
		HuffmanStringCodec stringCodec = new HuffmanStringCodec();
		stringCodec.createTree("go go loggers!"); //create encoding based on this String
		System.out.println(stringCodec.getEncoding());
		String encodedS = stringCodec.encode("google"); //string to encode
		System.out.println("Encoded as: " + encodedS);
		String decodedS = stringCodec.decode(encodedS);
		System.out.println("Decoded as: " + decodedS);
		
	
		/* FILE CODEC TESTING */
		//use a file chooser
		//		JFileChooser chooser = new JFileChooser("."); //open chooser at this folder (by default)
		//		chooser.setFileFilter(new FileNameExtensionFilter("Text files", "txt")); //for choosing txt files
		//		int returnVal = chooser.showOpenDialog(null);
		//		if(returnVal != JFileChooser.APPROVE_OPTION) //didn't pick anything
		//			  return; //quit
		//		File file = chooser.getSelectedFile();
	
//		File file = new File("hello.txt"); //hard-code filename
//		HuffmanFileCodec fileCodec = new HuffmanFileCodec();
//		fileCodec.createTree(file);
//		System.out.println(fileCodec.getEncoding());
//		File encodedF = fileCodec.encode(file); //encodes to filename.encoded
//		fileCodec.decode(encodedF, System.out); //decode and print to the console
//		System.out.println();
		
		//decode into a new file (for output)
		//		try{
		//			int fileExtIndex = file.getPath().lastIndexOf(".");
		//			File decodedF = new File(file.getPath().substring(0, fileExtIndex)+".decoded"+file.getPath().substring(fileExtIndex)); //insert .decoded into filename
		//			//alternatively, use a filechooser here!
		//			fileCodec.decode(encodedF, new PrintStream(decodedF)); //decode to specific file
		//		}catch(FileNotFoundException e){
		//			e.printStackTrace();
		//		}
	}	
}